var dllCLSID = "{25815CC0-43F4-3C75-8C3A-A139D9ADE740}";

var currentNIC = 0;			// the NIC we're displaying
var resetEvery = 10;		// reset the max value of the graph every n secs
var barWidth = 49;			// the max width of the bars
var maxHistory = 11;		// the maximum number of reading we should keep for the history
var refreshRate = 1000;		// time in ms between updates
var rescaleMethod = 2		// 1=zoomed in, 2=zoomed out

var scaleTo;				// the bandwidth to scale the bar too
var scaleToGraph;			// the bandwidth to scale the graph too
var resetCounter;			// counter used to reset the graphs
var xOffset;				// used to scale the graph

var NICbytesReceived, NICbytesSent, NICbandwidth, NICdescription, NICcount, tRefresh;

var history = new Array();
var gadgetPath = System.Gadget.path;
var charbackslash = new RegExp("\\\\", "g");

var oShell = new ActiveXObject("WScript.Shell");
var oFSO = new ActiveXObject("Scripting.FileSystemObject");


System.Gadget.onDock = dockedState;
System.Gadget.onUndock = dockedState;
System.Gadget.settingsUI = "Settings.html";


var bDebug = oFSO.FileExists(gadgetPath+"\\debug.txt");
try{
	if (bDebug)
		var debugLogFile = oFSO.OpenTextFile(gadgetPath+"\\debug.txt", 2);
} catch(err) {bDebug = false; debugLog("Open debug.txt error"+err.name+" - "+err.message)}

var NetLib, regRoot;

//register network library
if(bDebug) debugLog("Register ActiveX");
if(bDebug) debugLog("trying HKCU");
if (!activeDLL("HKCU")) {
	if(bDebug) debugLog("trying HKLM");
	if (!activeDLL("HKLM"))
		debugLog("Error creating DSXLib ActiveX object");
}


function dockedState() {
	System.Gadget.beginTransition();
	
	if (System.Gadget.docked) {
		document.body.style.width = 130;
		document.body.style.height = 67;
		var strokeweight = 1;
	} else {
		document.body.style.width = 130;
		document.body.style.height = 67;
		var strokeweight = 1;
	}

	graphReceived.strokeweight = strokeweight;
	graphSent.strokeweight = strokeweight;

	window.setTimeout(setZoom, 400);
	System.Gadget.endTransition(System.Gadget.TransitionType.morph, 0.2);
}

function setZoom() {
	if (System.Gadget.docked) {
		document.body.style.zoom = 0;
	} else {
		document.body.style.zoom = 0;
	}
}



function startUpGadget() {
	System.Gadget.background = "images/background.png";
	dockedState();
	try{
		//get the NIC's
		NICcount = NetLib.Initialize();
		initNIC();
		divBars.style.display = "inline"
		divGraph.style.display = "none"
	} catch (err) {debugLog("Can't initialize NetLib: "+err.name+ " - "+err.message)}
}



function initNIC() {
	try{window.clearTimeout(tRefresh)} catch(err) {debugLog("Cancel timer: "+err.name+ " - "+err.message)}

	try{
		//read the settings
		if (System.Gadget.Settings.readString("CurrentNIC") != "")
			currentNIC = parseInt(System.Gadget.Settings.readString("CurrentNIC"));
		if (System.Gadget.Settings.readString("ResetEvery") != "")
			resetEvery = parseInt(System.Gadget.Settings.readString("ResetEvery"));
		if (System.Gadget.Settings.readString("MaxHistory") != "")
			maxHistory = parseInt(System.Gadget.Settings.readString("MaxHistory"));
		if (System.Gadget.Settings.readString("RefreshRate") != "")
			refreshRate = parseInt(System.Gadget.Settings.readString("RefreshRate"));
		if (System.Gadget.Settings.readString("RescaleMethod") != "")
			rescaleMethod = parseInt(System.Gadget.Settings.readString("RescaleMethod"));
			
		//get the current NIC info
		NICbytesReceived = parseInt(NetLib.BytesReceived(currentNIC));
		NICbytesSent = parseInt(NetLib.BytesSent(currentNIC));
		NICbandwidth = parseInt(NetLib.Speed(currentNIC))/100;
		NICdescription = NetLib.Description(currentNIC);
		scaleTo = 0;
		scaleToGraph = 0;
		resetCounter = 0;

		xOffset = 1000/(maxHistory - 1);

		//initialise the history
		for (var i=0; i<maxHistory; i++)
			history[i] = [0,0];

		displayStats();

		//setup the update timer
		tRefresh = window.setInterval(displayStats, refreshRate);
	} catch (err) {debugLog("Can't read NIC: "+err.name+ " - "+err.message)}
}


// Register NetLib ActiveX component
function RegisterNetLib() {
	var classRoot = regRoot + "\\Software\\Classes\\NICGadget.NetworkInformation\\";
	var clsidRoot = regRoot + "\\Software\\Classes\\CLSID\\" + dllCLSID + "\\";

	try{
		oShell.RegWrite(classRoot,"NICGadget.NetworkInformation", "REG_SZ");
		oShell.RegWrite(classRoot + "CLSID\\", dllCLSID, "REG_SZ");
		oShell.RegWrite(clsidRoot, "NICGadget.NetworkInformation", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\", "mscoree.dll", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\ThreadingModel", "Both", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\Class", "NICGadget.NetworkInformation", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\Assembly", "NetLib, Version=1.0.2588.9125, Culture=neutral, PublicKeyToken=null", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\RuntimeVersion", "v2.0.50727", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\CodeBase", "file:///" + gadgetPath.replace(charbackslash, "/") + "/netlib.dll", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\1.0.2588.9125\\Class", "NICGadget.NetworkInformation", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\1.0.2588.9125\\Assembly", "NetLib, Version=1.0.2588.9125, Culture=neutral, PublicKeyToken=null", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\1.0.2588.9125\\RuntimeVersion", "v2.0.50727", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\1.0.2588.9125\\CodeBase", "file:///" + gadgetPath.replace(charbackslash, "/") + "/netlib.dll", "REG_SZ");
		oShell.RegWrite(clsidRoot + "ProgId\\", "NICGadget.NetworkInformation", "REG_SZ");
		oShell.RegWrite(clsidRoot + "ProgId\\Implemented Categories\\{62C8FE65-4EBB-45E7-B440-6E39B2CDBF29}\\", "", "REG_SZ");
	} catch(err) {debugLog("RegisterNetLib: "+err.name+" - "+err.message)}
}


function terminate() {
	try{NetLib.Terminate()} catch(err) {debugLog("Can't dispose of NetLib variables")}

	NetLib = null;

	UnregisterNetLib();
}


// Unregister DirectSound ActiveX component
function UnregisterNetLib() {
	var classRoot = regRoot + "\\Software\\Classes\\NICGadget.NetworkInformation\\";
	var clsidRoot = regRoot + "\\Software\\Classes\\CLSID\\" + dllCLSID + "\\";

	try{		
		oShell.RegDelete(clsidRoot + "ProgId\\Implemented Categories\\{62C8FE65-4EBB-45E7-B440-6E39B2CDBF29}\\");
		oShell.RegDelete(clsidRoot + "ProgId\\Implemented Categories\\");
		oShell.RegDelete(clsidRoot + "ProgId\\");
		oShell.RegDelete(clsidRoot + "InprocServer32\\1.0.2588.9125\\");
		oShell.RegDelete(clsidRoot + "InprocServer32\\");
		oShell.RegDelete(clsidRoot);
		oShell.RegDelete(classRoot + "CLSID\\");
		oShell.RegDelete(classRoot);
	} catch(err) {debugLog("UnregisterNetLib: "+err.name+" - "+err.message)}
}



// Try to register the DLL
function activeDLL(root) {
	regRoot = root;

	try{
		RegisterNetLib();
		NetLib = new ActiveXObject("NICGadget.NetworkInformation");
	} catch(err) {
		NetLib = null;
		UnregisterNetLib();
		return false;
	}
	return true;
}



//log a debug entry
function debugLog(str) {
	try{
		System.Debug.outputString(str);
		if (bDebug)
			debugLogFile.WriteLine(str);
	} catch(err) {}
}



function displayStats() {
try{
	//should we reset the scale
	if (resetEvery > 0)
	{
		if (resetCounter++ == resetEvery)
		{
			scaleTo = 0;
			scaleToGraph = 0;
			resetCounter = 0;
			for (var i=0; i<maxHistory; i++)
			{
				if (history[i][0] > scaleToGraph) scaleToGraph = history[i][0];
				if (history[i][1] > scaleToGraph) scaleToGraph = history[i][1];
			}
		}
	}

	var bytesReceived = parseInt(NetLib.BytesReceived(currentNIC));
	var bytesSent = parseInt(NetLib.BytesSent(currentNIC));
	var intervalDivisor = refreshRate/1000;
	var bytesReceivedPerSec = parseInt((bytesReceived - NICbytesReceived) / intervalDivisor);
	var bytesSentPerSec = parseInt((bytesSent - NICbytesSent) / intervalDivisor);

	// account for the machine being in hibernation
	if (bytesReceivedPerSec < 0) bytesReceivedPerSec = 0;
	if (bytesSentPerSec < 0) bytesSentPerSec = 0;
	
	NICbytesReceived = bytesReceived;
	NICbytesSent = bytesSent;

	// add the values to the history array
	if (history.push([bytesReceivedPerSec, bytesSentPerSec]) > maxHistory)
		var tmp = history.shift();

	//update bar
	if (scaleTo < bytesReceivedPerSec) scaleTo = bytesReceivedPerSec;
	if (scaleTo < bytesSentPerSec) scaleTo = bytesSentPerSec;
	if (scaleTo < NICbandwidth/100) scaleTo = NICbandwidth/100;

	var sentKB = parseInt(bytesSentPerSec/1024);
	var receivedKB = parseInt(bytesReceivedPerSec/1024);
	//bikke gezeurd iere moet normaal 1024 zijn maar tis voor de schoonte van de gadget, 4 cijfers is te lang dus alles boven de 1000 afronden
	divReceived.innerText = divReceived2.innerText = (receivedKB >= 1000) ? parseInt(receivedKB/1000) + " M" : receivedKB + " k";
	divSent.innerText = divSent2.innerText = (sentKB >= 1000) ? parseInt(sentKB/1000) + " M" : sentKB + " k";

	barReceived.style.width = parseInt(barWidth / (scaleTo / bytesReceivedPerSec));
	barSent.style.width = parseInt(barWidth / (scaleTo / bytesSentPerSec));
	scaleText(divScale, scaleTo);
	
	//update graph
	if (scaleToGraph < history[maxHistory-1][0]) scaleToGraph = history[maxHistory-1][0];
	if (scaleToGraph < history[maxHistory-1][1]) scaleToGraph = history[maxHistory-1][1];
	if (rescaleMethod == 2 && scaleToGraph < NICbandwidth/100) scaleToGraph = NICbandwidth/100;

	var pathReceived = "m 0," + (1000 - parseInt(1000 / (scaleToGraph / history[0][0]))) + " l";
	var pathSent = "m 0," + (1000 - parseInt(1000 / (scaleToGraph / history[0][1]))) + " l";
	for (var i=1; i<maxHistory; i++)
	{
		pathReceived += " " + parseInt(i*xOffset) + ", " + (1000 - Math.round(1000 / (scaleToGraph / history[i][0])));
		pathSent += " " + parseInt(i*xOffset) + ", " + (1000 - Math.round(1000/ (scaleToGraph / history[i][1])));
		if (i<maxHistory - 1)
		{
			pathReceived += ",";
			pathSent += ",";
		}
	}
	graphReceived.path = pathReceived + " e"
	graphSent.path = pathSent + " e"
	scaleText(divScale2, scaleToGraph);
} catch(err) {debugLog(err.name+" - "+err.message)}
}



function scaleText(obj, value) {
	var tmp = value/1024;
	var title = (tmp>1024) ? String(tmp/1024).substring(0,4) + " MB" : parseInt(tmp) + "KB";
	obj.title = title + " / " + parseInt(NICbandwidth/1024/1024) + " MB";
	var GebruikVanTotaal = Math.round((value / NICbandwidth)*100);
	if (GebruikVanTotaal <= 1) GebruikVanTotaal = 1;
	if (GebruikVanTotaal >= 100) GebruikVanTotaal = 100;
	obj.innerText = GebruikVanTotaal + "%";
}



function switchDisplay() {
try{
	if (divGraph.style.display == "none")
	{
		divGraph.style.display = "inline";
		divBars.style.display = "inline";

	} else {
		divGraph.style.display = "inline";
		divBars.style.display = "inline";
	}
} catch(err) {debugLog(err.name+" - "+err.message)}
}